package netscape.softupdate;

import java.util.Enumeration;
import java.util.NoSuchElementException;
import netscape.security.PrivilegeManager;

final class RegKeyEnumerator implements Enumeration {
   private String path = "";
   private Registry reg;
   private int key;
   private int state;
   private int style;
   private PrivilegeManager privMgr;
   private String target;

   RegKeyEnumerator(Registry var1, int var2, int var3, String var4) {
      this.reg = var1;
      this.key = var2;
      this.style = var3;
      this.target = var4;
      this.privMgr = PrivilegeManager.getPrivilegeManager();
   }

   public boolean hasMoreElements() {
      PrivilegeManager.checkPrivilegeEnabled(this.target);
      String var1 = this.regNext(false);
      return var1 != null;
   }

   public Object nextElement() {
      PrivilegeManager.checkPrivilegeEnabled(this.target);
      this.path = this.regNext(true);
      if (this.path == null) {
         throw new NoSuchElementException("RegKeyEnumerator");
      } else {
         return this.path;
      }
   }

   private native String regNext(boolean var1);
}
