package netscape.softupdate;

import netscape.security.AppletSecurity;
import netscape.security.PrivilegeManager;
import netscape.security.Target;

class InstallExecute extends InstallObject {
   private String jarLocation;
   private String tempFile;

   InstallExecute(SoftwareUpdate var1, String var2) {
      super(var1);
      this.jarLocation = var2;
      PrivilegeManager var3 = AppletSecurity.getPrivilegeManager();
      Target var4 = Target.findTarget("Impersonator");
      var3.enablePrivilege(var4);
      Target var5 = Target.findTarget(SoftwareUpdate.targetNames[1]);
      var3.enablePrivilege(var5, super.softUpdate.GetPrincipal());
   }

   protected void ExtractFile() throws SoftUpdateException {
      PrivilegeManager var1 = AppletSecurity.getPrivilegeManager();
      Target var2 = Target.findTarget("Impersonator");
      Target var3 = Target.findTarget(SoftwareUpdate.targetNames[1]);
      var1.enablePrivilege(var2);
      var1.enablePrivilege(var3, super.softUpdate.GetPrincipal());
      this.tempFile = super.softUpdate.ExtractJARFile(this.jarLocation);
   }

   protected void Complete() throws SoftUpdateException {
      PrivilegeManager var2 = AppletSecurity.getPrivilegeManager();
      Target var3 = Target.findTarget("Impersonator");
      var2.enablePrivilege(var3);
      Target var1 = Target.findTarget(SoftwareUpdate.targetNames[1]);
      var2.enablePrivilege(var1, super.softUpdate.GetPrincipal());
      this.NativeComplete();
      var2.revertPrivilege(var1);
   }

   protected void Abort() {
      this.NativeAbort();
   }

   private native void NativeComplete() throws SoftUpdateException;

   private native void NativeAbort();

   public String toString() {
      return Strings.details_ExecuteProgress() + this.tempFile;
   }
}
