package netscape.softupdate;

import java.util.Enumeration;
import java.util.NoSuchElementException;
import netscape.security.PrivilegeManager;

final class RegEntryEnumerator implements Enumeration {
   private String name = "";
   private Registry reg;
   private int key;
   private int state;
   private String target;

   RegEntryEnumerator(Registry var1, int var2, String var3) {
      this.reg = var1;
      this.key = var2;
      this.target = var3;
   }

   public boolean hasMoreElements() {
      PrivilegeManager.checkPrivilegeEnabled(this.target);
      String var1 = this.regNext(false);
      return var1 != null;
   }

   public Object nextElement() {
      PrivilegeManager.checkPrivilegeEnabled(this.target);
      this.name = this.regNext(true);
      if (this.name == null) {
         throw new NoSuchElementException("RegEntryEnumerator");
      } else {
         return this.name;
      }
   }

   private native String regNext(boolean var1);
}
