package netscape.softupdate;

public class Trigger {
   public static int DEFAULT_MODE;
   public static int FORCE_MODE = 1;
   public static int SILENT_MODE = 2;

   public static native boolean UpdateEnabled();

   public static VersionInfo GetVersionInfo(String var0) {
      return UpdateEnabled() ? VersionRegistry.componentVersion(var0) : null;
   }

   public static native boolean StartSoftwareUpdate(String var0, int var1);

   public static boolean ConditionalSoftwareUpdate(String var0, String var1, VersionInfo var2, int var3) {
      try {
         boolean var4 = false;
         if (var2 != null && var1 != null) {
            int var5 = VersionRegistry.validateComponent(var1);
            if (var5 != 3 && var5 != 9) {
               VersionInfo var6 = VersionRegistry.componentVersion(var1);
               if (var2.compareTo(var6) > 0) {
                  var4 = true;
               }
            } else {
               var4 = true;
            }
         } else {
            var4 = true;
         }

         return var4 ? StartSoftwareUpdate(var0, var3) : false;
      } catch (Throwable var7) {
         var7.printStackTrace();
         return false;
      }
   }
}
