package netscape.softupdate;

final class WinProfileItem extends InstallObject {
   private WinProfile profile;
   private String section;
   private String key;
   private String value;

   WinProfileItem(WinProfile var1, String var2, String var3, String var4) throws SoftUpdateException {
      super(var1.softUpdate());
      this.profile = var1;
      this.section = var2;
      this.key = var3;
      this.value = var4;
   }

   protected void Complete() throws SoftUpdateException {
      this.profile.finalWriteString(this.section, this.key, this.value);
   }

   float GetInstallOrder() {
      return 4.0F;
   }

   public String toString() {
      return "Write " + this.profile.filename() + ": [" + this.section + "] " + this.key + "=" + this.value;
   }
}
